function [Overall_HRV_features,HRV_label] = get_HRV_features(Overall_filtered_signals,new_Fs)
       
       HRV_label = 0;
       selected_signal = Overall_filtered_signals;
       
       [qrs_amp_raw,qrs_i_raw,delay] = pan_tompkin(double(selected_signal),new_Fs,0);
       
       if (length(qrs_i_raw) <= 5) || (isempty(qrs_i_raw) == 1)
          [qrs_amp_raw,qrs_i_raw,delay] = pan_tompkin(double(selected_signal),new_Fs/2,0);
       end
    
       if (length(qrs_i_raw) <= 5) || (isempty(qrs_i_raw) == 1)
          selected_signal = selected_signal(500:end);
          [qrs_amp_raw,qrs_i_raw,delay] = pan_tompkin(double(selected_signal),new_Fs,0);
       end
       
       if (length(qrs_i_raw) <= 5) || (isempty(qrs_i_raw) == 1)
          selected_signal = Overall_filtered_signals;
          selected_signal(selected_signal > 2) = 0;
          [qrs_amp_raw,qrs_i_raw,delay] = pan_tompkin(double(selected_signal),new_Fs,0);
       end
       
       if (length(qrs_i_raw) <= 5) || (isempty(qrs_i_raw) == 1)
          HRV_label = 1;
       end
       
       if HRV_label ~= 1
       selected_portion = diff(qrs_i_raw)./new_Fs;
        
       selected_portion_kurtosis = kurtosis(selected_portion);
       selected_portion_skewness = skewness(selected_portion);   
       
       selected_portion_freq = repmat(selected_portion,1,70);

        [hrv_td] = hrv_time_edit(selected_portion,50/1000);
        AVNN = hrv_td.AVNN./1000;
        SDNN = hrv_td.SDNN./1000;
        RMSSD = hrv_td.RMSSD./1000;
        pNN50 = hrv_td.pNN0./100;
        SEM = hrv_td.SEM./1000;
        time_features = [AVNN;SDNN;RMSSD;pNN50;SEM];
        
        [hrv_fd] = hrv_freq_edit(selected_portion_freq);
        hrv_fd2 = table2array(hrv_fd);
        hrv_fd2 = hrv_fd2./1000;
        freq_features = [hrv_fd2'];
        
        [hrv_nl] = hrv_nonlinear_edit(selected_portion_freq);
        hrv_nl2 = table2array(hrv_nl);
        hrv_nl2(1,1) = hrv_nl2(1,1)./100;
        hrv_nl2(1,2) = hrv_nl2(1,2)./100;
        nonlinear_features = hrv_nl2';
        
        [hrv_frag] = hrv_fragmentation_edit(selected_portion);
        hrv_frag2 = table2array(hrv_frag);
        fragmentation_features = hrv_frag2'./100;

        all_hrv_features = [time_features;freq_features;nonlinear_features;fragmentation_features];
        histogram_features = [selected_portion_kurtosis;selected_portion_skewness];
        Overall_HRV_features = [all_hrv_features;histogram_features];
        
       else
           
        Overall_HRV_features = zeros(27,1);
        
       end
   
end