function [Overall_SWD_features,SWD_OCs] = get_SWD_features(Overall_filtered_signals,new_Fs,threshold,plotting1)

%%
    selected_signal = normalize(Overall_filtered_signals);
    
    x    = selected_signal';
    fs   = new_Fs;
    dt   = 1 / fs;
    L    = length(x);
    t    = 0:dt:(L - 1) * dt;
    nfft = 2 ^ nextpow2(L);
    X    = abs(fft(x, nfft)) / L;
    f    = (fs / 2) * linspace(0, 1, nfft/2);
%     figure;
%     subplot(1, 2, 1); plot(t, x); 
%     subplot(1, 2, 2); plot(f, X(1:end/2));

    L = length(x);
    % param_struct = defaultSWDparams(L);
    min_peak = 0.1; %0.005;
    component_std = 0.1; %0.01;
    welch_window = round(L * 0.2);
    cf = 0;
    param_struct  = struct('P_th',min_peak, ...
                           'StD_th',component_std, ...
                           'Welch_window',welch_window);
    % With this parameter you can control the internal clustering the algorithm does. 
    % If it is very small, no clustering happens. Large values (>0.4) may
    % cluster all components.
    param_struct.clustering_factor = cf;

%     tic
    [cmps, residal] = SWD_V4(double(x), param_struct);
%     toc

    cmps_srtd = cmps;
    [Px_main, w_main] = pwelch(x);
    Pcmps   = pwelch(cmps_srtd);
    
    if size(cmps_srtd,2) <= 2
    L = length(x);
    % param_struct = defaultSWDparams(L);
    min_peak = 0.03; %0.005;
    component_std = 0.03; %0.01;
    welch_window = round(L * 0.2);
    param_struct  = struct('P_th',min_peak, ...
                           'StD_th',component_std, ...
                           'Welch_window',welch_window);
    % With this parameter you can control the internal clustering the algorithm does. 
    % If it is very small, no clustering happens. Large values (>0.4) may
    % cluster all components.
    param_struct.clustering_factor = cf;

%     tic
    [cmps, residal] = SWD_V4(double(x), param_struct);
%     toc

    cmps_srtd = cmps;
    [Px_main, w_main] = pwelch(x);
    Pcmps   = pwelch(cmps_srtd);
    end
    
    if size(cmps_srtd,2) <= 2
    L = length(x);
    % param_struct = defaultSWDparams(L);
    min_peak = 0.01; %0.005;
    component_std = 0.01; %0.01;
    welch_window = round(L * 0.2);
    param_struct  = struct('P_th',min_peak, ...
                           'StD_th',component_std, ...
                           'Welch_window',welch_window);
    % With this parameter you can control the internal clustering the algorithm does. 
    % If it is very small, no clustering happens. Large values (>0.4) may
    % cluster all components.
    param_struct.clustering_factor = cf;

%     tic
    [cmps, residal] = SWD_V4(double(x), param_struct);
%     toc

    cmps_srtd = cmps;
    [Px_main, w_main] = pwelch(x);
    Pcmps   = pwelch(cmps_srtd);
    end
    
    
%     if size(cmps_srtd,2) <= 5
%     L = length(x);
%     % param_struct = defaultSWDparams(L);
%     min_peak = 0.01; %0.005;
%     component_std = 0.01; %0.01;
%     welch_window = round(L * 0.2);
%     param_struct  = struct('P_th',min_peak, ...
%                            'StD_th',component_std, ...
%                            'Welch_window',welch_window);
%     % With this parameter you can control the internal clustering the algorithm does. 
%     % If it is very small, no clustering happens. Large values (>0.4) may
%     % cluster all components.
%     param_struct.clustering_factor = cf;
% 
% %     tic
%     [cmps, residal] = SWD_V4(double(x), param_struct);
% %     toc
% 
%     cmps_srtd = cmps;
%     [Px_main, w_main] = pwelch(x);
%     Pcmps   = pwelch(cmps_srtd);
%     end
    
    if isnan(cmps_srtd(1,end)) ~= 1
        
    if plotting1 == 1
    figure;
    NoC = size(cmps_srtd, 2);
    subplot(NoC+1, 2, 1); plot(x);%title('Pacemaker Arrhythmia Original Signal')%ylim([min(x) max(x)])
    subplot(NoC+1, 2, 2); plot(w_main/pi, Px_main);
    for i = 1:NoC

        subplot(NoC+1, 2, 2*(i-1)+3); plot(cmps_srtd(:, i));%title(['OC ', num2str(i)])%ylim([min(x) max(x)])
        subplot(NoC+1, 2, 2*(i-1)+4); plot(w_main/pi, Pcmps(:, i));
    end
    end
    
    index = [];
    for j = 1:size(cmps_srtd,2)
        selected_OC = cmps_srtd(:,j);
        if sum(selected_OC) == 0
           index = j;
        end
    end
    cmps_srtd(:,index) = [];
    
    numerofcomponents = size(cmps_srtd,2);
    
    y_SWD_fix = cmps_srtd;
    y_SWD_added_total_high = 0;
    y_SWD_added_total_low = 0;
    y_SWD2 = double.empty;
    ffMean_total = double.empty;
for SWD_count = 1:1:numerofcomponents
    [Px, w] = pwelch(y_SWD_fix(:, SWD_count));
    [max_val max_loc] = max(Px);
    [locationr locationc] = find(Px >= max_val./1.5);
    w2 = w_main./pi;
    w_final = w2(locationr);
    ffMean = mean(w_final);
   
    ffMean_total(SWD_count,1) = ffMean;
    
    if (ffMean > threshold) %%&& (ffMean <= 0.15)
       y_SWD_added_total_high = y_SWD_added_total_high + y_SWD_fix(:, SWD_count); 
    end
         
    if (ffMean <= threshold) %%&& (ffMean >= 0.005)
       y_SWD_added_total_low = y_SWD_added_total_low + y_SWD_fix(:, SWD_count); 
    end
    
end
    
    if y_SWD_added_total_low == 0
       y_SWD_added_total_low = y_SWD_fix(:,1);
       y_SWD_added_total_high = y_SWD_added_total_high - y_SWD_added_total_low;
    end
    
    if y_SWD_added_total_high == 0
       y_SWD_added_total_high = sum(y_SWD_fix(:,2:end),2);
       y_SWD_added_total_low = y_SWD_added_total_low - y_SWD_added_total_high;
    end
    
    y_SWD2 = [y_SWD_added_total_high,y_SWD_added_total_low]';
        
    y_SWD_plot = y_SWD2';   
    y_SWD_plot(:,1) = y_SWD_plot(:,1) + residal;
    
    if plotting1 == 1
    figure;
    Pcmps2 = pwelch(y_SWD_plot);
    NoC = size(y_SWD_plot, 2);
    subplot(NoC+1, 2, 1); plot(x,'-k','linewidth',0.5);
    xticklabels({[num2str(0./new_Fs)],[num2str(1000./new_Fs)],[num2str(2000./new_Fs)],[num2str(3000./new_Fs)],[num2str(4000./new_Fs)],[num2str(5000./new_Fs)]})
    ylabel('Normalized amp.')
    ylim([min(x) max(x)])
    subplot(NoC+1, 2, 2); plot(w_main/pi, Px_main,'-k','linewidth',0.5);
    ylabel('Power/frequency')
    xlim([min(w_main/pi) max(w_main/pi)])
    ylim([min(Px_main) max(Px_main)])
    for i = 1:NoC 
    subplot(NoC+1, 2, 2*(i-1)+3); plot(y_SWD_plot(:, i),'-k','linewidth',0.5);
    xticklabels({[num2str(0./new_Fs)],[num2str(1000./new_Fs)],[num2str(2000./new_Fs)],[num2str(3000./new_Fs)],[num2str(4000./new_Fs)],[num2str(5000./new_Fs)]})
    ylabel('Normalized amp.')
    ylim([min(x) max(x)])
    if i == NoC
       xlabel('Time (s)')
    end
    %ylim([min(x) max(x)])
    subplot(NoC+1, 2, 2*(i-1)+4); plot(w_main/pi, Pcmps2(:, i),'-k','linewidth',0.5);
    ylabel('Power/frequency')
    if i == NoC
       xlabel('Normalized frequency')
    end
    xlim([min(w_main/pi) max(w_main/pi)])
    ylim([min(Px_main) max(Px_main)])
    end
    
    end
    
    else
        
    y_SWD2 = [cmps_srtd(:,1)';residal'];
    
    end
%     
%     figure;
%     subplot(2,1,1),plot(x)
%     subplot(2,1,2),plot(y_SWD2(1,:)+y_SWD2(2,:)+residal')

    y_SWD2 = [x';y_SWD2];

    %%
    entropy_features = double.empty;
    HFD = double.empty;
    KFD = double.empty;
    for k = 1:size(y_SWD2,1)
        signal = normalize(y_SWD2(k,:));
%         entropy_features(1,k) = wentropy(normalize(y_SWD2(k,:)),'shannon')./1000;
        entropy_features(1,k) = sampen(signal, 1, 0.2);
        HFD(1,k) = Higuchi_FD(signal, 5); 
        KFD(1,k) = Katz_FD(signal);
    end
    kurtosis_features = double.empty;
    for k = 1:size(y_SWD2,1)
        kurtosis_features(1,k) = kurtosis(normalize(y_SWD2(k,:)));
    end
    skewness_features = double.empty;
    for k = 1:size(y_SWD2,1)
        skewness_features(1,k) = skewness(normalize(y_SWD2(k,:)));
    end  
    ZCR_features = double.empty;
    for k = 1:size(y_SWD2,1)
        ZCR_features(1,k) = ZCR(normalize(y_SWD2(k,:)));
    end 
    features = [entropy_features,HFD,KFD,kurtosis_features,skewness_features,ZCR_features];
    
    Overall_SWD_features = single(features');
    SWD_OCs = single(normalize(y_SWD2(2:3,:)'));

end
