function [Final_HRV_features,Final_SWD_features,Final_SWD_OCs] = get_features2(selected_data, selected_header,leads_idx,threshold,plotting1,plotting2) %get_ECGLeads_features

% read number of leads, sample frequency and adc_gain from the header.
[recording,Total_time,num_leads,Fs,adc_gain,age,sex,Baseline] = extract_data_from_header(selected_header);
num_leads = length(leads_idx);
nan_check = 0;

Overall_filtered_signals = single.empty;
for lead_id = 1:num_leads

LeadswGain = (selected_data(lead_id,:)-Baseline(lead_id))./adc_gain(lead_id);
LeadswGain = single(LeadswGain);
       
[Overall_filtered_signals(:,lead_id)] = filter_ECG(LeadswGain,Fs);
new_Fs = 64;

end

yy2 = smoothdata(Overall_filtered_signals,'gaussian',100);
data_baselined = Overall_filtered_signals - yy2;
Overall_filtered_signals = single(normalize(data_baselined));
            
%%%%%%%%%%%%%%% Summed scenarios
summed_signal_1 = normalize(nansum(Overall_filtered_signals(:,[1:12]),2));
summed_signal_2 = normalize(nansum(Overall_filtered_signals(:,[1:6]),2));
summed_signal_3 = normalize(nansum(Overall_filtered_signals(:,[1,2,3,8]),2));
summed_signal_4 = normalize(nansum(Overall_filtered_signals(:,[1,2,8]),2));
summed_signal_5 = normalize(nansum(Overall_filtered_signals(:,[1,2]),2));

% figure;
% subplot(5,1,1),plot(summed_signal_1,'-k')
% subplot(5,1,2),plot(summed_signal_2,'-k')
% subplot(5,1,3),plot(summed_signal_3,'-k')
% subplot(5,1,4),plot(summed_signal_4,'-k')
% subplot(5,1,5),plot(summed_signal_5,'-k')

%%%%%%%%%%%%%%% HRV per scenario

plot_index = 0;
% [Overall_HRV_features_1] = get_HRV_features2(summed_signal_1,new_Fs,plot_index);
% [Overall_HRV_features_2] = get_HRV_features2(summed_signal_2,new_Fs,plot_index);
% [Overall_HRV_features_3] = get_HRV_features2(summed_signal_3,new_Fs,plot_index);
% [Overall_HRV_features_4] = get_HRV_features2(summed_signal_4,new_Fs,plot_index);
[Overall_HRV_features_5] = get_HRV_features2(summed_signal_5,new_Fs,plot_index);

Final_HRV_features = [age;sex;Overall_HRV_features_5];

%%%%%%%%%%%%%%% SWD per scenario

[Overall_SWD_features_1,SWD_OCs_1] = get_SWD_features_2(summed_signal_1,new_Fs,threshold,plotting1);
[Overall_SWD_features_2,SWD_OCs_2] = get_SWD_features_2(summed_signal_2,new_Fs,threshold,plotting1);
[Overall_SWD_features_3,SWD_OCs_3] = get_SWD_features_2(summed_signal_3,new_Fs,threshold,plotting1);
[Overall_SWD_features_4,SWD_OCs_4] = get_SWD_features_2(summed_signal_4,new_Fs,threshold,plotting1);
[Overall_SWD_features_5,SWD_OCs_5] = get_SWD_features_2(summed_signal_5,new_Fs,threshold,plotting1);

% selected_signal = summed_signal_1;
% selected_OCs = SWD_OCs_1;
% figure;
% subplot(3,1,1),plot(selected_signal,'-k'),ylim([min(selected_signal) max(selected_signal)])
% subplot(3,1,2),plot(selected_OCs(:,1),'-k'),ylim([min(selected_signal) max(selected_signal)])
% subplot(3,1,3),plot(selected_OCs(:,2),'-k'),ylim([min(selected_signal) max(selected_signal)])

Final_SWD_features = [{Overall_SWD_features_1};...
                      {Overall_SWD_features_2};...
                      {Overall_SWD_features_3};...
                      {Overall_SWD_features_4};...
                      {Overall_SWD_features_5}];

Final_SWD_OCs = [{SWD_OCs_1};...
                 {SWD_OCs_2};...
                 {SWD_OCs_3};...
                 {SWD_OCs_4};...
                 {SWD_OCs_5}];           

end
