function [Overall_SWD_merged_features,Overall_merged_OCs] = merge_OCs(Overall_SWD_OCs,new_Fs,threshold,plotting2)
     
% % %     all_OCs = double.empty;
% % %     for OC_id = 1:size(Overall_SWD_OCs,1)
% % %         all_OCs = [all_OCs,Overall_SWD_OCs{OC_id,1}];
% % %     end
% % %     
    summed_OCs = zeros(size(Overall_SWD_OCs,1),1);
    for j = 1:size(Overall_SWD_OCs,2)
        summed_OCs = summed_OCs + Overall_SWD_OCs(:,j);
    end
    [Px_main, w_main] = pwelch(summed_OCs);
    
    numerofcomponents = size(Overall_SWD_OCs,2);
    y_SWD_fix = Overall_SWD_OCs;
    y_SWD_added_total_high = 0;
    y_SWD_added_total_low = 0;
    y_SWD2 = double.empty;
    ffMean_total = double.empty;
for SWD_count = 1:1:numerofcomponents
    [Px, w] = pwelch(y_SWD_fix(:, SWD_count));
    [max_val max_loc] = max(Px);
    [locationr locationc] = find(Px >= max_val./1.5);
    w2 = w_main./pi;
    w_final = w2(locationr);
    ffMean = mean(w_final);
   
    ffMean_total(SWD_count,1) = ffMean;
    
    if (ffMean > threshold) %%&& (ffMean <= 0.15)
       y_SWD_added_total_high = y_SWD_added_total_high + y_SWD_fix(:, SWD_count); 
    end
         
    if (ffMean <= threshold) %%&& (ffMean >= 0.005)
       y_SWD_added_total_low = y_SWD_added_total_low + y_SWD_fix(:, SWD_count); 
    end
    
end  
        
   y_SWD2 = [y_SWD_added_total_high,y_SWD_added_total_low]';

    
    
    x = y_SWD2(1,:) + y_SWD2(2,:);
    
%     Overall_merged_OCs = [x;y_SWD2];
    Overall_merged_OCs = [y_SWD2];

    [Px_main, w_main] = pwelch(x);
    
    y_SWD_plot = y_SWD2';   
    
    if plotting2 == 1
    figure;
    Pcmps2 = pwelch(y_SWD_plot);
    NoC = size(y_SWD_plot, 2);
    subplot(NoC+1, 2, 1); plot(x,'-k','linewidth',0.5);
    xticklabels({[num2str(0./new_Fs)],[num2str(1000./new_Fs)],[num2str(2000./new_Fs)],[num2str(3000./new_Fs)],[num2str(4000./new_Fs)],[num2str(5000./new_Fs)]})
    ylabel('Normalized amp.')
    ylim([min(x) max(x)])
    subplot(NoC+1, 2, 2); plot(w_main/pi, Px_main,'-k','linewidth',0.5);
    ylabel('Power/frequency')
    xlim([min(w_main/pi) max(w_main/pi)])
    ylim([min(Px_main) max(Px_main)])
    for i = 1:NoC 
    subplot(NoC+1, 2, 2*(i-1)+3); plot(y_SWD_plot(:, i),'-k','linewidth',0.5);
    xticklabels({[num2str(0./new_Fs)],[num2str(1000./new_Fs)],[num2str(2000./new_Fs)],[num2str(3000./new_Fs)],[num2str(4000./new_Fs)],[num2str(5000./new_Fs)]})
    ylabel('Normalized amp.')
    ylim([min(x) max(x)])
    if i == NoC
       xlabel('Time (s)')
    end
    %ylim([min(x) max(x)])
    subplot(NoC+1, 2, 2*(i-1)+4); plot(w_main/pi, Pcmps2(:, i),'-k','linewidth',0.5);
    ylabel('Power/frequency')
    if i == NoC
       xlabel('Normalized frequency')
    end
    xlim([min(w_main/pi) max(w_main/pi)])
    ylim([min(Px_main) max(Px_main)])
    end
    
    end

    entropy_features = double.empty;
    HFD = double.empty;
    KFD = double.empty;
    for k = 1:size(Overall_merged_OCs,1)
        signal = normalize(Overall_merged_OCs(k,:));
%         entropy_features(1,k) = wentropy(normalize(y_SWD2(k,:)),'shannon')./1000;
        entropy_features(1,k) = sampen(signal, 1, 0.2);
        HFD(1,k) = Higuchi_FD(signal, 5); 
        KFD(1,k) = Katz_FD(signal);
    end
    kurtosis_features = double.empty;
    for k = 1:size(Overall_merged_OCs,1)
        kurtosis_features(1,k) = kurtosis(normalize(Overall_merged_OCs(k,:)));
    end
    skewness_features = double.empty;
    for k = 1:size(Overall_merged_OCs,1)
        skewness_features(1,k) = skewness(normalize(Overall_merged_OCs(k,:)));
    end  
    ZCR_features = double.empty;
    for k = 1:size(Overall_merged_OCs,1)
        ZCR_features(1,k) = ZCR(normalize(Overall_merged_OCs(k,:)));
    end 
    features = [entropy_features,HFD,KFD,kurtosis_features,skewness_features,ZCR_features];
    
    Overall_SWD_merged_features = single(features');
    
end