%% Apply classifier model to test set

function [score, label,classes] = team_testing_code(data,header_data, loaded_model)

model   = loaded_model.model;
classes = loaded_model.classes;

num_classes = length(classes);

label = zeros([1,num_classes]);
score = ones([1,num_classes]);

% Extract features from test data
tmp_hea = strsplit(header_data{1},' ');
num_leads = str2num(tmp_hea{2});
[leads, leads_idx] = get_leads(header_data,num_leads);

if length(leads_idx) == 12
   
   threshold = 0.1;
   plotting1 = 0;
   % Extract features
   [Final_HRV_features,Final_SWD_features,Final_SWD_OCs] = get_features2_test(data,header_data,leads_idx,threshold,plotting1);

   for i = 1:5
   selected_signal = Final_SWD_OCs{i,1};
   layer = 'bilstm';
   featuresTest = activations(model{i, 1},selected_signal,layer);
   featuresTest = single(featuresTest');
   featuresTest = [featuresTest,Final_HRV_features',Final_SWD_features{i,1}'];
   [x,y] = find(isnan(featuresTest) == 1);
   featuresTest(x,y) = 0;
   featuresTest = normalize(featuresTest,2);
       
   [out_class,scores_NN(i,:)] = classify(model{i, 2},featuresTest,'MiniBatchSize',512);
   end

end

if length(leads_idx) == 6
   
   threshold = 0.1;
   plotting1 = 0;
   % Extract features
   [Final_HRV_features,Final_SWD_features,Final_SWD_OCs] = get_features2_test(data,header_data,leads_idx,threshold,plotting1);

   for i = 1:2
   selected_signal = Final_SWD_OCs{i,1};
   layer = 'bilstm';
   featuresTest = activations(model{i, 1},selected_signal,layer);
   featuresTest = single(featuresTest');
   featuresTest = [featuresTest,Final_HRV_features',Final_SWD_features{i,1}'];
   [x,y] = find(isnan(featuresTest) == 1);
   featuresTest(x,y) = 0;
   featuresTest = normalize(featuresTest,2);
       
   [out_class,scores_NN(i,:)] = classify(model{i, 2},featuresTest,'MiniBatchSize',512);
   end

end

if length(leads_idx) == 4
   
   threshold = 0.1;
   plotting1 = 0;
   % Extract features
   [Final_HRV_features,Final_SWD_features,Final_SWD_OCs] = get_features2_test(data,header_data,leads_idx,threshold,plotting1);

   for i = 1:3
   selected_signal = Final_SWD_OCs{i,1};
   layer = 'bilstm';
   featuresTest = activations(model{i, 1},selected_signal,layer);
   featuresTest = single(featuresTest');
   featuresTest = [featuresTest,Final_HRV_features',Final_SWD_features{i,1}'];
   [x,y] = find(isnan(featuresTest) == 1);
   featuresTest(x,y) = 0;
   featuresTest = normalize(featuresTest,2);
       
   [out_class,scores_NN(i,:)] = classify(model{i, 2},featuresTest,'MiniBatchSize',512);
   end

end

if length(leads_idx) == 3
   
   threshold = 0.1;
   plotting1 = 0;
   % Extract features
   [Final_HRV_features,Final_SWD_features,Final_SWD_OCs] = get_features2_test(data,header_data,leads_idx,threshold,plotting1);

   for i = 1:2
   selected_signal = Final_SWD_OCs{i,1};
   layer = 'bilstm';
   featuresTest = activations(model{i, 1},selected_signal,layer);
   featuresTest = single(featuresTest');
   featuresTest = [featuresTest,Final_HRV_features',Final_SWD_features{i,1}'];
   [x,y] = find(isnan(featuresTest) == 1);
   featuresTest(x,y) = 0;
   featuresTest = normalize(featuresTest,2);
       
   [out_class,scores_NN(i,:)] = classify(model{i, 2},featuresTest,'MiniBatchSize',512);
   end

end

if length(leads_idx) == 2
   
   threshold = 0.1;
   plotting1 = 0;
   % Extract features
   [Final_HRV_features,Final_SWD_features,Final_SWD_OCs] = get_features2_test(data,header_data,leads_idx,threshold,plotting1);

   for i = 1:1
   selected_signal = Final_SWD_OCs{i,1};
   layer = 'bilstm';
   featuresTest = activations(model{i, 1},selected_signal,layer);
   featuresTest = single(featuresTest');
   featuresTest = [featuresTest,Final_HRV_features',Final_SWD_features{i,1}'];
   [x,y] = find(isnan(featuresTest) == 1);
   featuresTest(x,y) = 0;
   featuresTest = normalize(featuresTest,2);
       
   [out_class,scores_NN(i,:)] = classify(model{i, 2},featuresTest,'MiniBatchSize',512);
   end

end

%%%%%%%%%%%%%%% BEST
if length(leads_idx) == 2
   score =  scores_NN;
else
   score = sum(scores_NN); %%% Make it sum
end

score = normalize(score,'range'); 
[~,idx] = find(score >= 0.5);
label(idx)=1;

end
